%global __strip %{mingw_strip}
%global __objdump %{mingw_objdump}
%global _use_internal_dependency_generator 0
%global __find_requires %{mingw_findrequires}
%global __find_provides %{mingw_findprovides}
%define __debug_install_post %{mingw_debug_install_post}

%global mingw_pkg_name pdcurses
%global mingw_build_win32 1
%global mingw_build_win64 1

Name:           mingw-pdcurses
Version:        3.4
Release:        10%{?dist}
Summary:        Curses library for MinGW

License:        Public Domain
Group:          Development/Libraries
URL:            http://pdcurses.sourceforge.net/
Source0:        http://downloads.sourceforge.net/pdcurses/PDCurses-%{version}.tar.gz
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildArch:      noarch

Patch0:         mingw32-pdcurses-3.4-build.patch

BuildRequires:  mingw-filesystem >= 65
BuildRequires:  mingw32-gcc
BuildRequires:  mingw32-binutils
BuildRequires:  mingw64-gcc
BuildRequires:  mingw64-binutils

%{?mingw_default_requires}
%{?mingw_debug_package}

%description
PDCurses is a public domain curses library for DOS, OS/2, Win32, X11
and SDL, implementing most of the functions available in X/Open and
System V R4 curses. It supports many compilers for these
platforms. The X11 port lets you recompile existing text-mode curses
programs to produce native X11 applications.

Note that ncurses is not available for MinGW / Windows.  Applications
which need curses functionality can use this package, provided they
don't use any of the extensions specific to ncurses.


# Mingw32
%package -n mingw32-%{mingw_pkg_name}
Summary:        %{summary}

%description -n mingw32-%{mingw_pkg_name}
PDCurses is a public domain curses library for DOS, OS/2, Win32, X11
and SDL, implementing most of the functions available in X/Open and
System V R4 curses. It supports many compilers for these
platforms. The X11 port lets you recompile existing text-mode curses
programs to produce native X11 applications.

Note that ncurses is not available for MinGW / Windows.  Applications
which need curses functionality can use this package, provided they
don't use any of the extensions specific to ncurses.

# Mingw64
%package -n mingw64-%{mingw_pkg_name}
Summary:        %{summary}

%description -n mingw64-%{mingw_pkg_name}
PDCurses is a public domain curses library for DOS, OS/2, Win32, X11
and SDL, implementing most of the functions available in X/Open and
System V R4 curses. It supports many compilers for these
platforms. The X11 port lets you recompile existing text-mode curses
programs to produce native X11 applications.

Note that ncurses is not available for MinGW / Windows.  Applications
which need curses functionality can use this package, provided they
don't use any of the extensions specific to ncurses.


%prep
%setup -q -n PDCurses-%{version}
%patch0 -p1

%build
cp -R win32 build_win32
cp -R win32 build_win64

pushd build_win32
make -f mingwin32.mak \
  CC=%{mingw32_cc} \
  STRIP=%{mingw32_strip} \
  LINK=%{mingw32_cc} \
  WIDE=Y UTF8=Y DLL=Y
popd

pushd build_win64
make -f mingwin32.mak \
  CC=%{mingw64_cc} \
  STRIP=%{mingw64_strip} \
  LINK=%{mingw64_cc} \
  WIDE=Y UTF8=Y DLL=Y
popd


%install
rm -rf $RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT%{mingw32_bindir}
mkdir -p $RPM_BUILD_ROOT%{mingw32_libdir}
mkdir -p $RPM_BUILD_ROOT%{mingw32_includedir}

install build_win32/*.exe $RPM_BUILD_ROOT%{mingw32_bindir}
install build_win32/pdcurses.dll $RPM_BUILD_ROOT%{mingw32_bindir}/pdcurses.dll
install build_win32/pdcurses.a $RPM_BUILD_ROOT%{mingw32_libdir}/libpdcurses.dll.a
install -m 0644 curses.h panel.h term.h $RPM_BUILD_ROOT%{mingw32_includedir}

mkdir -p $RPM_BUILD_ROOT%{mingw64_bindir}
mkdir -p $RPM_BUILD_ROOT%{mingw64_libdir}
mkdir -p $RPM_BUILD_ROOT%{mingw64_includedir}

install build_win64/*.exe $RPM_BUILD_ROOT%{mingw64_bindir}
install build_win64/pdcurses.dll $RPM_BUILD_ROOT%{mingw64_bindir}/pdcurses.dll
install build_win64/pdcurses.a $RPM_BUILD_ROOT%{mingw64_libdir}/libpdcurses.dll.a
install -m 0644 curses.h panel.h term.h $RPM_BUILD_ROOT%{mingw64_includedir}


%clean
rm -rf $RPM_BUILD_ROOT


%files -n mingw32-%{mingw_pkg_name}
%defattr(-,root,root)
%{mingw32_bindir}/pdcurses.dll
%{mingw32_libdir}/libpdcurses.dll.a
%{mingw32_includedir}/curses.h
%{mingw32_includedir}/panel.h
%{mingw32_includedir}/term.h
%{mingw32_bindir}/firework.exe
%{mingw32_bindir}/newdemo.exe
%{mingw32_bindir}/ptest.exe
%{mingw32_bindir}/rain.exe
%{mingw32_bindir}/testcurs.exe
%{mingw32_bindir}/tuidemo.exe
%{mingw32_bindir}/xmas.exe
%{mingw32_bindir}/worm.exe

%files -n mingw64-%{mingw_pkg_name}
%defattr(-,root,root)
%{mingw64_bindir}/pdcurses.dll
%{mingw64_libdir}/libpdcurses.dll.a
%{mingw64_includedir}/curses.h
%{mingw64_includedir}/panel.h
%{mingw64_includedir}/term.h
%{mingw64_bindir}/firework.exe
%{mingw64_bindir}/newdemo.exe
%{mingw64_bindir}/ptest.exe
%{mingw64_bindir}/rain.exe
%{mingw64_bindir}/testcurs.exe
%{mingw64_bindir}/tuidemo.exe
%{mingw64_bindir}/xmas.exe
%{mingw64_bindir}/worm.exe


%changelog
* Fri May 27 2011 Marc-André Lureau <marcandre.lureau@redhat.com> 3.4-10
- Updated to build with mingw64

* Sun Feb 13 2011 Erik van Pienbroek <epienbro@fedoraproject.org> 3.4-9
- Added support to build against the mingw-w64 toolchain

* Tue Feb 08 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.4-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Wed Jan 13 2010 Richard W.M. Jones <rjones@redhat.com> - 3.4-7
- Fix Source0 URL.

* Sat Jul 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.4-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Wed Feb 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.4-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Fri Feb 20 2009 Richard W.M. Jones <rjones@redhat.com> - 3.4-4
- Rebuild for mingw32-gcc 4.4

* Fri Jan 16 2009 Richard Jones <rjones@redhat.com> - 3.4-3
- Remove +x permissions on the header files.

* Sat Nov 22 2008 Richard Jones <rjones@redhat.com> - 3.4-2
- Rename implib to libpdcurses.dll.a so that libtool can use it.

* Thu Sep 25 2008 Richard Jones <rjones@redhat.com> - 3.4-1
- Initial RPM release.
